<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\TkDI;
use HCM\FPA\Entity\FpaitecalcfolhaEntity;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpacalculofolhaEntity;
use HCM\FPA\Entity\FpatipomovimentEntity;

class EventosFaltasIntervalo{

    private $_evento;
    private $_calculo_folha;
    private $_item_calculo_fonte;

    public function __construct($entityManager, $hcmParameters){
        
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_evento = new FpaeventomEntity($entityManager, $hcmParameters);
        $this->_calculo_folha_fonte = new FpacalculofolhaEntity($entityManager, $hcmParameters);
        $this->_itens_calculo_fonte = new FpaitecalcfolhaEntity($entityManager, $hcmParameters);
    }
    
    public function calcula(
        $vinculo, $dt_inicial, $dt_final, $nrTipoModalidadeCalc,
        $nrOcorrenciaCalc, $nrOrgPadrao
    ){

        if (is_object($dt_inicial)) {
            $dt_inicial_calc = clone $dt_inicial;
            $dt_inicial_calc = DateUtil::setDay($dt_inicial_calc, 1);
        }
        
        $lista_nr_calculo_folha = $this->_calculo_folha_fonte->retornaCalculoFolhaPeriodo(
            $vinculo->getNrorg(), FpatipomovimentEntity::TP_MOV_MENSAL, $dt_inicial_calc, $dt_final, $nrTipoModalidadeCalc,
            $nrOcorrenciaCalc
        );

        $lista_nr_eventos = $this->_evento->retornaListaEventoFalta($vinculo->getNrorg(), $nrOrgPadrao);
        if (empty($lista_nr_eventos) === false) {
            $lista_eventos  = $this->_itens_calculo_fonte->totalizaItensHistorico(
                $vinculo, $lista_nr_calculo_folha, $lista_nr_eventos
            );
            return $lista_eventos;
        } else {
            return;
        }
    }


}