<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\DateUtil;

class FpaDireitotpdemisEntity extends TkEntity
{

    const IDDIREITOTPDEMIS_SIM = 'S';
    const IDDIREITOTPDEMIS_NAO = 'N';
    
    public function __construct($entityManager, $hcmParameters){
        $this->hcmParameters = $hcmParameters;
        parent::__construct(null, $entityManager);
    }
    
    public function retornaTipoDireitoPorTipoDemissao($nrOrg, $nrOrgPadrao, $mesCompetencia){
        $resultado = $this->entityManager->getRepository(Repositories::FPA_DIREITOTPDEMIS)->retornaTipoDireitoPorTipoDemissao($nrOrg, $nrOrgPadrao, $mesCompetencia);
        return $resultado;
    }

    public function carregaTipoDireitoPorTipoDemissao($nrOrg, $nrOrgPadrao, $mesCompetencia){

        $itens = $this->getItems();
        if (count($itens) === 0){
            $itens = $this->retornaTipoDireitoPorTipoDemissao($nrOrg, $nrOrgPadrao, $mesCompetencia);

            foreach($itens as $item){
                if ($item->getIddireitotpdemis() === self::IDDIREITOTPDEMIS_SIM) {
                    $listaDireito = $this->getItem($item->getNrtpdemissao());
                    $listaDireito[] = $item->getNrtipodireito();
                    $this->addItem($listaDireito, $item->getNrtpdemissao());
                }
            }
        }
    }
}





