<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Remote\cURLRequest;
use Zeedhi\Framework\Remote\HttpInterface;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\FPA\Repository\BloqueioEventoVinculoRepository;
use Zeedhi\Framework\DataSource\ParameterBag;


class BloqueioEventoVinculoService {
    
    protected $entityManager;
    protected $hcmParameters;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ParameterBag $parameterBag, BloqueioEventoVinculoRepository $bloqueioVinculoRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->parameterBag = $parameterBag;
        $this->bloqueioEventVincRepository = $bloqueioVinculoRepository;
    }
    
    public function verificaEventoBloqueado ($nrorg, $nrevento, $tipoVinculo) {
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $nrorg_padrao = $this->hcmParameters->getNrorgPadrao();
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        $this->bloqueioEventVincService->retornaEventosBloqueados($nrorg, $nrorg_padrao, $dtmescompetenc, $nrevento, $tipoVinculo);
    }
    
}