<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 01/03/2016
 * Time: 10:58
 */

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use Teknisa\Libs\Util\Environment;
use HCM\Util\HCMParameters;

class GpeEscalastrabService {

    protected $entityManager;
    /** @var Environment */
    protected $environment;

    public function __construct(EntityManager $entityManager, Environment $environment, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->hcmParameters = $hcmParameters;
    }

    public function getEscalastrab($parameters, $conditions) {

        $nrorg          = $this->hcmParameters->getNrorgTrabalho();
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        
        $query = $this->entityManager->getConnection()->prepare("
            SELECT * FROM (
                SELECT
                  EH.*
                  FROM GPE_ESCALATRABM EM
                  JOIN GPE_ESCALATRABH EH
                    ON EM.NRESCALATRABM = EH.NRESCALATRABM
                   AND EM.NRORG = EH.NRORG
                 WHERE EM.NRORG   = :P_NRORG
                   AND EH.IDATIVO = 'S'
                   AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                           FROM GPE_ESCALATRABH 
                                          WHERE NRORG           = :P_NRORG
                                            AND NRESCALATRABM   = EH.NRESCALATRABM
                                            AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                  AND (EM.DTFIMVIGENCIA >= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY') 
                    OR EM.DTFIMVIGENCIA IS NULL)
                 ORDER BY NMESCALATRABH DESC)
            WHERE 1 = 1
            $conditions
        ");

        $query->execute(
            array(
                "P_NRORG" => $nrorg,
                "P_DTMESCOMPETENC" => $dtmescompetenc
            )
        );

        $result = $query->fetchAll();

        return $result;
    }

}