/* Sistemas Integrados TECNISA

Nome: 99PL_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Tabela CONSISTEFISCAL: Consistncias Fiscais.
Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CONSISTEFISCAL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_CONSISTEFISCAL' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_CONSISTEFISCAL
GO

CREATE TRIGGER LOG_FIS_CONSISTEFISCAL
ON CONSISTEFISCAL
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_NRSEQCONSISTE_OLD   VARCHAR(10);
   DECLARE @V_DSCONSISTENCIA_OLD  VARCHAR(250);
   DECLARE @V_CDIMPOSTO_OLD       VARCHAR(02);
   DECLARE @V_IDENTRSAIDOP_OLD    VARCHAR(01);
   DECLARE @V_CDFISCOPER_OLD      VARCHAR(04);
   DECLARE @V_CDCST1DIGT_OLD      VARCHAR(01);
   DECLARE @V_CDSITUTRIB_OLD      VARCHAR(02);
   DECLARE @V_CDFISCAL_OLD        VARCHAR(01);
   DECLARE @V_CDTPCREDPICOITE_OLD VARCHAR(03);
   DECLARE @V_IDTPBASECALC_OLD    VARCHAR(01);
   DECLARE @V_IDTPALIQUOTA_OLD    VARCHAR(01);
   DECLARE @V_IDTPVRIMPOSTO_OLD   VARCHAR(01);
   DECLARE @V_IDCONSISTELANC_OLD  VARCHAR(01);
   DECLARE @V_IDCONSISTEAPRO_OLD  VARCHAR(01);
   DECLARE @V_IDCONSPREDEFI_OLD   VARCHAR(01);
   DECLARE @V_IDCONSATIVA_OLD     VARCHAR(01);
   DECLARE @V_IDBLOQADMI_OLD      VARCHAR(01);

   DECLARE @V_NRSEQCONSISTE_NEW   VARCHAR(10);
   DECLARE @V_DSCONSISTENCIA_NEW  VARCHAR(250);
   DECLARE @V_CDIMPOSTO_NEW       VARCHAR(02);
   DECLARE @V_IDENTRSAIDOP_NEW    VARCHAR(01);
   DECLARE @V_CDFISCOPER_NEW      VARCHAR(04);
   DECLARE @V_CDCST1DIGT_NEW      VARCHAR(01);
   DECLARE @V_CDSITUTRIB_NEW      VARCHAR(02);
   DECLARE @V_CDFISCAL_NEW        VARCHAR(01);
   DECLARE @V_CDTPCREDPICOITE_NEW VARCHAR(03);
   DECLARE @V_IDTPBASECALC_NEW    VARCHAR(01);
   DECLARE @V_IDTPALIQUOTA_NEW    VARCHAR(01);
   DECLARE @V_IDTPVRIMPOSTO_NEW   VARCHAR(01);
   DECLARE @V_IDCONSISTELANC_NEW  VARCHAR(01);
   DECLARE @V_IDCONSISTEAPRO_NEW  VARCHAR(01);
   DECLARE @V_IDCONSPREDEFI_NEW   VARCHAR(01);
   DECLARE @V_IDCONSATIVA_NEW     VARCHAR(01);
   DECLARE @V_IDBLOQADMI_NEW      VARCHAR(01);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
     DELETED.NRSEQCONSISTE,
     DELETED.DSCONSISTENCIA,
     DELETED.CDIMPOSTO,
     DELETED.IDENTRSAIDOP,
     DELETED.CDFISCOPER,
     DELETED.CDCST1DIGT,
     DELETED.CDSITUTRIB,
     DELETED.CDFISCAL,
     DELETED.CDTPCREDPICOITE,
     DELETED.IDTPBASECALC,
     DELETED.IDTPALIQUOTA,
     DELETED.IDTPVRIMPOSTO,
     DELETED.IDCONSISTELANC,
     DELETED.IDCONSISTEAPRO,
     DELETED.IDCONSPREDEFI,
     DELETED.IDCONSATIVA,
     DELETED.IDBLOQADMI,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL
   FROM
     DELETED
   WHERE
     0 = (SELECT COUNT(*) FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
     DELETED.NRSEQCONSISTE,
     DELETED.DSCONSISTENCIA,
     DELETED.CDIMPOSTO,
     DELETED.IDENTRSAIDOP,
     DELETED.CDFISCOPER,
     DELETED.CDCST1DIGT,
     DELETED.CDSITUTRIB,
     DELETED.CDFISCAL,
     DELETED.CDTPCREDPICOITE,
     DELETED.IDTPBASECALC,
     DELETED.IDTPALIQUOTA,
     DELETED.IDTPVRIMPOSTO,
     DELETED.IDCONSISTELANC,
     DELETED.IDCONSISTEAPRO,
     DELETED.IDCONSPREDEFI,
     DELETED.IDCONSATIVA,
     DELETED.IDBLOQADMI,
     INSERTED.NRSEQCONSISTE,
     INSERTED.DSCONSISTENCIA,
     INSERTED.CDIMPOSTO,
     INSERTED.IDENTRSAIDOP,
     INSERTED.CDFISCOPER,
     INSERTED.CDCST1DIGT,
     INSERTED.CDSITUTRIB,
     INSERTED.CDFISCAL,
     INSERTED.CDTPCREDPICOITE,
     INSERTED.IDTPBASECALC,
     INSERTED.IDTPALIQUOTA,
     INSERTED.IDTPVRIMPOSTO,
     INSERTED.IDCONSISTELANC,
     INSERTED.IDCONSISTEAPRO,
     INSERTED.IDCONSPREDEFI,
     INSERTED.IDCONSATIVA,
     INSERTED.IDBLOQADMI
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDIMPOSTO     = DELETED.CDIMPOSTO    AND
      INSERTED.NRSEQCONSISTE = DELETED.NRSEQCONSISTE

   UNION ALL

   SELECT
     'I' IDCOMANDO,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     INSERTED.NRSEQCONSISTE,
     INSERTED.DSCONSISTENCIA,
     INSERTED.CDIMPOSTO,
     INSERTED.IDENTRSAIDOP,
     INSERTED.CDFISCOPER,
     INSERTED.CDCST1DIGT,
     INSERTED.CDSITUTRIB,
     INSERTED.CDFISCAL,
     INSERTED.CDTPCREDPICOITE,
     INSERTED.IDTPBASECALC,
     INSERTED.IDTPALIQUOTA,
     INSERTED.IDTPVRIMPOSTO,
     INSERTED.IDCONSISTELANC,
     INSERTED.IDCONSISTEAPRO,
     INSERTED.IDCONSPREDEFI,
     INSERTED.IDCONSATIVA,
     INSERTED.IDBLOQADMI
   FROM INSERTED
   WHERE 0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NRSEQCONSISTE_OLD,
                                 @V_DSCONSISTENCIA_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_IDENTRSAIDOP_OLD,
                                 @V_CDFISCOPER_OLD,
                                 @V_CDCST1DIGT_OLD,
                                 @V_CDSITUTRIB_OLD,
                                 @V_CDFISCAL_OLD,
                                 @V_CDTPCREDPICOITE_OLD,
                                 @V_IDTPBASECALC_OLD,
                                 @V_IDTPALIQUOTA_OLD,
                                 @V_IDTPVRIMPOSTO_OLD,
                                 @V_IDCONSISTELANC_OLD,
                                 @V_IDCONSISTEAPRO_OLD,
                                 @V_IDCONSPREDEFI_OLD,
                                 @V_IDCONSATIVA_OLD,
                                 @V_IDBLOQADMI_OLD,

                                 @V_NRSEQCONSISTE_NEW,
                                 @V_DSCONSISTENCIA_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_IDENTRSAIDOP_NEW,
                                 @V_CDFISCOPER_NEW,
                                 @V_CDCST1DIGT_NEW,
                                 @V_CDSITUTRIB_NEW,
                                 @V_CDFISCAL_NEW,
                                 @V_CDTPCREDPICOITE_NEW,
                                 @V_IDTPBASECALC_NEW,
                                 @V_IDTPALIQUOTA_NEW,
                                 @V_IDTPVRIMPOSTO_NEW,
                                 @V_IDCONSISTELANC_NEW,
                                 @V_IDCONSISTEAPRO_NEW,
                                 @V_IDCONSPREDEFI_NEW,
                                 @V_IDCONSATIVA_NEW,
                                 @V_IDBLOQADMI_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SET @V_DESC    = 'Consistncia = '         + ' ' + ISNULL(@V_NRSEQCONSISTE_NEW, '')     + ' ' +
                          'Descrio = '            + ' ' + ISNULL(@V_DSCONSISTENCIA_NEW, '')    + ' ' +
                          'Imposto = '              + ' ' + ISNULL(@V_CDIMPOSTO_NEW, '')         + ' ' +
                          'E/S = '                  + ' ' + ISNULL(@V_IDENTRSAIDOP_NEW, '')      + ' ' +
                          'CFOP = '                 + ' ' + ISNULL(@V_CDFISCOPER_NEW, '')        + ' ' +
                          '1 Dig. Cst = '           + ' ' + ISNULL(@V_CDCST1DIGT_NEW, '')        + ' ' +
                          'Cst = '                  + ' ' + ISNULL(@V_CDSITUTRIB_NEW, '')        + ' ' +
                          'CF = '                   + ' ' + ISNULL(@V_CDFISCAL_NEW, '')          + ' ' +
                          'Tp. Credto = '           + ' ' + ISNULL(@V_CDTPCREDPICOITE_NEW, '')   + ' ' +
                          'BC = '                   + ' ' + ISNULL(@V_IDTPBASECALC_NEW, '')      + ' ' +
                          'Aliq = '                 + ' ' + ISNULL(@V_IDTPALIQUOTA_NEW, '')      + ' ' +
                          'Imp = '                  + ' ' + ISNULL(@V_IDTPVRIMPOSTO_NEW, '')     + ' ' +
                          'Cons. Lanc = '           + ' ' + ISNULL(@V_IDCONSISTELANC_NEW, '')    + ' ' +
                          'Cons. Aprov = '          + ' ' + ISNULL(@V_IDCONSISTEAPRO_NEW, '')    + ' ' +
                          'Pre def. = '             + ' ' + ISNULL(@V_IDCONSPREDEFI_NEW, '')     + ' ' +
                          'Cons. Ativa = '          + ' ' + ISNULL(@V_IDCONSATIVA_NEW, '')       + ' ' +
                          'Bloqueio = '             + ' ' + ISNULL(@V_IDBLOQADMI_NEW, '') ;

         SET @V_ITPESQ = @V_CDIMPOSTO_NEW+@V_NRSEQCONSISTE_NEW;
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            SET @V_DESC   = 'Consistncia = '       + ' ' + ISNULL(@V_NRSEQCONSISTE_NEW, '')     + ' ' +
                          'Descrio = '            + ' ' + ISNULL(@V_DSCONSISTENCIA_NEW, '')    + ' ' +
                          'Imposto = '              + ' ' + ISNULL(@V_CDIMPOSTO_NEW, '')         + ' ' +
                          'E/S = '                  + ' ' + ISNULL(@V_IDENTRSAIDOP_NEW, '')      + ' ' +
                          'CFOP = '                 + ' ' + ISNULL(@V_CDFISCOPER_NEW, '')        + ' ' +
                          '1 Dig. Cst = '           + ' ' + ISNULL(@V_CDCST1DIGT_NEW, '')        + ' ' +
                          'Cst = '                  + ' ' + ISNULL(@V_CDSITUTRIB_NEW, '')        + ' ' +
                          'CF = '                   + ' ' + ISNULL(@V_CDFISCAL_NEW, '')          + ' ' +
                          'Tp. Credto = '           + ' ' + ISNULL(@V_CDTPCREDPICOITE_NEW, '')   + ' ' +
                          'BC = '                   + ' ' + ISNULL(@V_IDTPBASECALC_NEW, '')      + ' ' +
                          'Aliq = '                 + ' ' + ISNULL(@V_IDTPALIQUOTA_NEW, '')      + ' ' +
                          'Imp = '                  + ' ' + ISNULL(@V_IDTPVRIMPOSTO_NEW, '')     + ' ' +
                          'Cons. Lanc = '           + ' ' + ISNULL(@V_IDCONSISTELANC_NEW, '')    + ' ' +
                          'Cons. Aprov = '          + ' ' + ISNULL(@V_IDCONSISTEAPRO_NEW, '')    + ' ' +
                          'Pre def. = '             + ' ' + ISNULL(@V_IDCONSPREDEFI_NEW, '')     + ' ' +
                          'Cons. Ativa = '          + ' ' + ISNULL(@V_IDCONSATIVA_NEW, '')       + ' ' +
                          'Bloqueio = '             + ' ' + ISNULL(@V_IDBLOQADMI_NEW, '');

            SET @V_ITPESQ = @V_CDIMPOSTO_NEW+@V_NRSEQCONSISTE_NEW;
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               SET @V_DESC   = 'Consistncia = '    + ' ' + ISNULL(@V_NRSEQCONSISTE_OLD, '')     + ' ' +
                          'Descrio = '            + ' ' + ISNULL(@V_DSCONSISTENCIA_OLD, '')    + ' ' +
                          'Imposto = '              + ' ' + ISNULL(@V_CDIMPOSTO_OLD, '')         + ' ' +
                          'E/S = '                  + ' ' + ISNULL(@V_IDENTRSAIDOP_OLD, '')      + ' ' +
                          'CFOP = '                 + ' ' + ISNULL(@V_CDFISCOPER_OLD, '')        + ' ' +
                          '1 Dig. Cst = '           + ' ' + ISNULL(@V_CDCST1DIGT_OLD, '')        + ' ' +
                          'Cst = '                  + ' ' + ISNULL(@V_CDSITUTRIB_OLD, '')        + ' ' +
                          'CF = '                   + ' ' + ISNULL(@V_CDFISCAL_OLD, '')          + ' ' +
                          'Tp. Credto = '           + ' ' + ISNULL(@V_CDTPCREDPICOITE_OLD, '')   + ' ' +
                          'BC = '                   + ' ' + ISNULL(@V_IDTPBASECALC_OLD, '')      + ' ' +
                          'Aliq = '                 + ' ' + ISNULL(@V_IDTPALIQUOTA_OLD, '')      + ' ' +
                          'Imp = '                  + ' ' + ISNULL(@V_IDTPVRIMPOSTO_OLD, '')     + ' ' +
                          'Cons. Lanc = '           + ' ' + ISNULL(@V_IDCONSISTELANC_OLD, '')    + ' ' +
                          'Cons. Aprov = '          + ' ' + ISNULL(@V_IDCONSISTEAPRO_OLD, '')    + ' ' +
                          'Pre def. = '             + ' ' + ISNULL(@V_IDCONSPREDEFI_OLD, '')     + ' ' +
                          'Cons. Ativa = '          + ' ' + ISNULL(@V_IDCONSATIVA_OLD, '')       + ' ' +
                          'Bloqueio = '             + ' ' + ISNULL(@V_IDBLOQADMI_OLD, '');

               SET @V_ITPESQ = @V_CDIMPOSTO_OLD+@V_NRSEQCONSISTE_OLD;
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;

      SET @V_DTOPER = GETDATE();

      INSERT INTO LOGCONSISTEFISCAL
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('CONSISTEFISCAL',
                   @V_DTOPER,
                   @V_NMOPERADOR,
                   @V_IDTIPOOPER,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,300),
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NRSEQCONSISTE_OLD,
                                 @V_DSCONSISTENCIA_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_IDENTRSAIDOP_OLD,
                                 @V_CDFISCOPER_OLD,
                                 @V_CDCST1DIGT_OLD,
                                 @V_CDSITUTRIB_OLD,
                                 @V_CDFISCAL_OLD,
                                 @V_CDTPCREDPICOITE_OLD,
                                 @V_IDTPBASECALC_OLD,
                                 @V_IDTPALIQUOTA_OLD,
                                 @V_IDTPVRIMPOSTO_OLD,
                                 @V_IDCONSISTELANC_OLD,
                                 @V_IDCONSISTEAPRO_OLD,
                                 @V_IDCONSPREDEFI_OLD,
                                 @V_IDCONSATIVA_OLD,
                                 @V_IDBLOQADMI_OLD,

                                 @V_NRSEQCONSISTE_NEW,
                                 @V_DSCONSISTENCIA_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_IDENTRSAIDOP_NEW,
                                 @V_CDFISCOPER_NEW,
                                 @V_CDCST1DIGT_NEW,
                                 @V_CDSITUTRIB_NEW,
                                 @V_CDFISCAL_NEW,
                                 @V_CDTPCREDPICOITE_NEW,
                                 @V_IDTPBASECALC_NEW,
                                 @V_IDTPALIQUOTA_NEW,
                                 @V_IDTPVRIMPOSTO_NEW,
                                 @V_IDCONSISTELANC_NEW,
                                 @V_IDCONSISTEAPRO_NEW,
                                 @V_IDCONSPREDEFI_NEW,
                                 @V_IDCONSATIVA_NEW,
                                 @V_IDBLOQADMI_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_CONSISTEFISCAL','5.30.xxx';
GO
